; *******************************************************************
; 100 Hz generator on GP5
; *******************************************************************
;
; 2014 Copyright by Frank Buss
; *******************************************************************

			list p=12F509
			#include <p12f509.inc>
  
			__CONFIG _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC

            variables udata
flipflop    res 1
tmp1        res 1
tmp2        res 1

            code
			org 0x0000

			; set calibration value
			movwf OSCCAL

			; set GP5 as output
			movlw b'011111'
			tris GPIO

			; infinite loop, cycles per loop: 10,000
loop:		call flip
			nop
			nop
			call flip
			goto loop

			; toggle GP5 pin
flip:		movf flipflop, w
			xorlw b'100000'
			movwf GPIO
			movwf flipflop
			
			; long delay
			movlw d'226'
			movwf tmp1
delay1:		movlw d'6'
			movwf tmp2
delay2:		decfsz tmp2, f
			goto delay2
			decfsz tmp1, f
			goto delay1

			; fine tuning
			movlw d'5'
			movwf tmp2
delay3:		decfsz tmp2, f
			goto delay3
			nop
			
			retlw 0

; uncomment this, if you erased the calibration value, or for fine tuning
;			org 0x3ff
;			movlw 0x1a

			end
